/*
  Reminder.h
  Copyright (c) 1996-1999 Dwight D. Everhart.  All rights reserved.
  This source code has been released to the public.  Use is governed
  by the MiscKit license, which basically means you can use it for
  whatever purpose you like, commercial or non-commercial.  This code
  is provided AS IS.  No warranty is expressed or implied.
*/

#import <Foundation/NSObject.h>
//#import <AppKit/dpsOpenStep.h>
//#import <AppKit/NSDPSContext.h>

@class Alarm, Appointment, Date;


typedef unsigned long remindTime_t;


@interface Reminder: NSObject

{
   Appointment *appt;
   Date *apptTime;
   Alarm *alarm;
   remindTime_t remindTime;
   struct {
      unsigned int enabled: 1;
   } rFlags;
}

+ (void) initialize;

- (id) init;
- (id) initWithAppointment: (Appointment *) appointment;
- (id) copyWithZone:(NSZone *)zone;
- (void) dealloc;

- (Appointment *) appointment;
- (void) setAppointment: (Appointment *) newAppointment;

- (remindTime_t) remindTime;
- (void) setRemindTime: (remindTime_t) newRemindTime;

- (Date *) reminderTime;
- (Date *) appointmentTime;

- (BOOL) isEnabled;
- (void)setEnabled:(BOOL)isEnabled;

- (BOOL) isCompleted;
- (void) setCompleted: (BOOL) isCompleted;

- (BOOL) getNextReminderTime: (Date *) reminderTime
  includeMissedReminders: (BOOL) includeMissedReminders
  includeImmediateReminders: (BOOL) includeImmediateReminders;

- (void) startTimer;
- (void) startTimerAndExecuteMissedReminders: (BOOL) executeMissed
  andImmediateReminders: (BOOL) executeImmediateReminders;
- (void) startInitialTimerAndExecuteMissedReminders: (int) executeMissedReminders;
- (void) stopTimer;
- (void) executeReminderAndReschedule: (id) sender;
- (void) doReminder;

- (void) objectDidChange: (id) object;
- (void) objectWillDealloc: (id) object;

@end
