/*
  ReminderPanel.m
  Copyright (c) 1996-1999 Dwight D. Everhart.  All rights reserved.

  This source code has been released to the public.  Use is governed
  by the MiscKit license, which basically means you can use it for
  whatever purpose you like, commercial or non-commercial.  This code
  is provided AS IS.  No warranty is expressed or implied.
*/

#import "ReminderPanel.h"
#import "Appointment.h"
#import "Date.h"
#import <AppKit/AppKit.h>


#define AUTOSAVE_NAME @"ReminderPanel"



@implementation ReminderPanel



- (void) awakeFromNib
{
   [self setFrameAutosaveName: AUTOSAVE_NAME];
}



- (void) runModalWithAppointment: (Appointment *) appointment
                         andTime: (Date *) apptTime
{
   [titleField setStringValue: [appointment title]];
   [timeField setStringValue: [apptTime description]];
   [descriptionText setAttributedString: [appointment descriptionText]];
   NSBeep();

   NS_DURING {
      [NSApp runModalForWindow:self];
   } NS_HANDLER {
      NSLog (@"ReminderPanel: Exception raised during modal loop");
   } NS_ENDHANDLER

   [self orderOut:self];
}



- (IBAction) ok: (id) sender
{
   [NSApp stopModal];
}



@end
